"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class CacheManager {
    constructor() {
        this.client = null;
        this.options = {
            excludeContext: true,
            ttlSeconds: 0,
            debug: false,
        };
    }
    setClient(client) {
        this.client = client;
        if (this.options && !this.options.ttlSeconds) {
            this.options.ttlSeconds = this.client.getClientTTL();
        }
    }
    setOptions(options) {
        this.options = options;
    }
}
exports.default = CacheManager;
