import * as NodeCache from 'node-cache';
import { CacheClient } from '../interfaces';
export declare class NodeCacheAdapter implements CacheClient {
    static responseCallback: (resolve: Function, reject: Function) => NodeCache.Callback<any>;
    private nodeCacheClient;
    constructor(nodeCacheClient: NodeCache.NodeCache);
    getClientTTL(): number;
    get(cacheKey: string): Promise<any>;
    /**
     * set - Sets a key equal to a value in a NodeCache cache
     *
     * @param cacheKey The key to store the value under
     * @param value    The value to store
     * @param ttl      Time to Live (how long, in seconds, the value should be cached)
     *
     * @returns {Promise}
     */
    set(cacheKey: string, value: any, ttl?: number): Promise<any>;
    del(cacheKey: string): Promise<any>;
}
