"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class NodeCacheAdapter {
    constructor(nodeCacheClient) {
        this.nodeCacheClient = nodeCacheClient;
    }
    ;
    getClientTTL() {
        return this.nodeCacheClient.options.stdTTL || 0;
    }
    get(cacheKey) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => this.nodeCacheClient.get(cacheKey, NodeCacheAdapter.responseCallback(resolve, reject)));
        });
    }
    ;
    /**
     * set - Sets a key equal to a value in a NodeCache cache
     *
     * @param cacheKey The key to store the value under
     * @param value    The value to store
     * @param ttl      Time to Live (how long, in seconds, the value should be cached)
     *
     * @returns {Promise}
     */
    set(cacheKey, value, ttl) {
        return __awaiter(this, void 0, void 0, function* () {
            if (ttl) {
                return new Promise((resolve, reject) => this.nodeCacheClient.set(cacheKey, value, ttl, NodeCacheAdapter.responseCallback(resolve, reject)));
            }
            return new Promise((resolve, reject) => this.nodeCacheClient.set(cacheKey, value, NodeCacheAdapter.responseCallback(resolve, reject)));
        });
    }
    ;
    del(cacheKey) {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => this.nodeCacheClient.del(cacheKey, NodeCacheAdapter.responseCallback(resolve, reject)));
        });
    }
    ;
}
exports.NodeCacheAdapter = NodeCacheAdapter;
NodeCacheAdapter.responseCallback = (resolve, reject) => (err, response) => {
    if (err) {
        reject(err);
    }
    else {
        resolve(response);
    }
};
